<html lang="en" class="+full-height"><head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <!-- Kwaeri CSS -->
        <link rel="stylesheet" href="https://mmod.gitlab.io/kwaeri-user-experience/dist/css/kux_md--comprehensive.min.css">

        <title>@kwaeri/filesystem</title>
    </head>
    <body class="+inverse-colors mdc-typography">


        <!-- The Side Menu - MDC Drawer Based. We add a bit of functionality to provide a feature rich Side Menu. -->
        <aside data-menu="side-menu" data-menu-type="hybrid-permanent-modal" data-menu-initialized="false" class="mdc-drawer side-menu +mimic-appbar +inverse ">
            <div class="mdc-drawer__toolbar-spacer"></div>
            <header class="mdc-drawer__header">
                <div class="mdc-drawer__header-content">
                  <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=YUW4CWCAABCU2" target="_blank" title="Donate to Massivley Modified" class="image-link +horizontally-centered"><div class="icon-donations"></div></a>
                </div>
            </header>
            <div class="mdc-drawer__content">

                <!-- The Side Menu nav element -->
                <nav id="icon-with-text-demo" class="mdc-list">
                    <!-- Side Menu Section Title -->
                    <span class="side-menu_section-title">Introduction</span>
                    <!-- Side Menu Section Nav -->
                    <ul class="side-menu_nav side-menu_menu-section">

                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="what-is-knkf" data-scroll-to-target="what-is-knkf">@kwaeri/filesystem?</button>
                        </li>

                        <!-- Side Menu Section Menu Item -->
                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="getting-started" data-expandable="getting-started" data-expandable-type="side-menu" aria-expanded="false">Getting Started</button>
                            <!-- Side Menu Section Menu Item Sub-Nav (otional) -->
                            <div class="side-menu_submenu-wrap">
                                <!-- Side Menu Sub Nav -->
                                <ul class="submenu_nav submenu_menu-section" data-expand="getting-started" data-expanded="false">

                                    <!-- And there we may place sub-nav_item for each fragment of the section -->
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="prerequisites" data-scroll-to-target="prerequisites">Prerequisites</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="installing-the-module" data-scroll-to-target="installing-the-module">Installing the Module</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="including-the-library" data-scroll-to-target="including-the-library">Including the Library</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="a-complete-example" data-scroll-to-target="a-complete-example">A Complete Example</a></li>
                                </ul>
                            </div>
                        </li>
                    </ul>

                    <!-- Side Menu Section Title -->
                    <span class="side-menu_section-title">Components</span>
                    <!-- Side Menu Section Nav -->
                    <ul class="side-menu_nav side-menu_menu-section">
                        <!-- Side Menu Section Menu Item -->
                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="API " data-expandable="api" data-expandable-type="side-menu" aria-expanded="false">API</button>
                            <!-- Side Menu Section Menu Item Sub-Nav (otional) -->
                            <div class="side-menu_submenu-wrap">
                                <!-- Side Menu Sub Nav -->
                                <ul class="submenu_nav submenu_menu-section" data-expand="api" data-expanded="false">

                                    <!-- And there we may place sub-nav_item for each fragment of the section -->
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="list" data-scroll-to-target="list">list()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="getDirectoryStructure" data-scroll-to-target="getDirectoryStructure">getDirectoryStructure()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="getFileInformation" data-scroll-to-target="getFileInformation">getFileInformation()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="exists" data-scroll-to-target="exists">exists()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="createDirectory" data-scroll-to-target="createDirectory">createDirectory()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="createFile" data-scroll-to-target="createFile">createFile()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="getFileSafeName" data-scroll-to-target="getFileSafeName">getFileSafeName()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="getCodeSafeName" data-scroll-to-target="getCodeSafeName">getCodeSafeName()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="alphaNumericSort" data-scroll-to-target="alphaNumericSort">alphaNumericSort()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="getPathToCWD" data-scroll-to-target="getPathToCWD">getPathToCWD()</a></li>
                                </ul>
                            </div>
                        </li>
                    </ul>


                    <div class="side-menu-select-item-divider mdc-list-divider" role="separator"></div>

                    <a class="mdc-list-item" href="mailto:support@mmod.co">
                        <i class="material-icons mdc-list-item__graphic" title="Email Support" aria-hidden="true">email</i>Email Support
                    </a>
                </nav>
            </div>
        </aside> <!-- End the Side Menu-->

        <div class="mdc-drawer-scrim"></div>

        <!-- The topAppBar - we only add a couple things to give additional functionality from what Google gives us. -->
        <header class="mdc-top-app-bar mdc-top-app-bar--fixed" data-animation="rebound-scroll" data-rebounded="false" data-menu="top-menu">
            <div class="mdc-top-app-bar__row">
                <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-start">
                    <a data-menu="navigation-drawer" data-drawer="permanent" class="material-icons mdc-top-app-bar__navigation-icon hidden">menu</a>
                    <div class="navbar_brand icon-logo-badge-small-dev"></div>
                    <span class="mdc-top-app-bar__title">kwaeri.io</span>
                </section>
                <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-end" role="toolbar">
                    <div class="mdc-menu-surface--anchor">
                        <a class="material-icons mdc-top-app-bar__action-item" data-dropdown="filedownload" title="Download @Kwaeri/filesystem" aria-label="Download" alt="Download">file_download</a>
                        <div class="mdc-menu mdc-menu-surface" tabindex="-1" data-menu="dropdown" data-for="filedownload">
                            <ul class="mdc-menu__items mdc-list" role="menu" aria-hidden="true">
                                <li class="mdc-list-item" role="menuitem" tabindex="0">
                                    <a href="https://gitlab.com//kwaeri/node-kit/filesystem/-/archive/master/filesystem-master.zip" class="drop-down_item" title="Download .zip" aria-label="Download .zip" alt="Download .zip">Download a Zip</a>
                                </li>
                                <li class="mdc-list-item" role="menuitem" tabindex="0">
                                    <a href="https://gitlab.com/kwaeri/node-kit/filesystem/-/archive/master/filesystem-master.tar.gz" class="drop-down_item" title="Download .tar.gz" aria-label="Download .tar.gz" alt="Download .tar.gz">Download a Tarball</a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <a href="/coverage" class="material-icons mdc-top-app-bar__action-item" title="Code Coverage" aria-label="Code Coverage" alt="Code Coverage">book</a>
                </section>
            </div>
        </header> <!-- End the topAppBar -->

        <!-- The Site/App main content -->
        <div id=client-display" data-feature="focus" class="container mdc-top-app-bar--fixed-adjust +flex-side-menu +flex-scrollspy">

            <div class="container-fluid +top">

                <section class="featured +read-easy">

                    <article class="featured_article">


                        <!---<div data-drag="test-handle" class="draggable">
                            <div data-handle="test-handle" class="draggable_handle">Draggable Window: Handle</div>
                            <div class="draggable_content">
                                <p>This is a draggable element.</p>
                            </div>

                        </div>-->


                        <div class="article_header">

                            <div class="article_header+wider">
                                <h1>@kwaeri/filesystem</h1>
                                <p>The @kwaeri/filesystem component of the @kwaeri/node-kit application platform.</p>
                            </div>

                            <div class="article_header+related">

                                <span class="content_related-list+title">Contents</span>
                                <ul class="content_related-list">
                                    <li>Related content I</li>
                                    <li>Related content II</li>
                                    <li>Related content III</li>
                                </ul>
                            </div>

                        </div>

                        <hr>

                        <div id="what-is-knkf" class="article_header+sub">
                            <h6>@kwaeri/filesystem provides a wrapper for the NodeJS core fs module which allows for easy manipulation of the filesystem.</h6>

                            <p>The @kwaeri/filesystem component offers myriad methods for helping to execute both simple and complex tasks which are commonly leveraged in everyday application logic. These methods allow developers to easily query the contents of a path, get the directory structure underlying a path, determine the types of resources found, check if resources exist, write resources, format file-name-safe and code-safe strings, sort files (in an array)  alpha-numerically, and even get the full path to the current working directory.</p>
                        </div>

                        <hr>

                        <div class="article_body">

                            <!-- A section for Getting Started -->
                            <section id="getting-started" class="article_section"> <!-- Can have a max-width (controlled by media queries) set, but we already do that on featured + read-easy in this example  -->

                                <!-- Section Header -->
                                <h2 class="article_chapter-title">Getting Started</h2>
                                <!-- End of Section Header -->

                                <!-- Section Body -->
                                <div class="section_body"> <!-- Material.io's equivalent, article__copy, only has postiion relative set.. we can do this too! -->


                                    <!-- Section Body Fragment (there should be many ) -->
                                    <div id="prerequisites" class="fragment +collapsible" data-collapsible="prerequisites" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="prerequisites" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Preparing for Installation</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="prerequisites">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="prerequisites">

                                                <p>This section covers the prerequisites for making use of the @kwaeri/filesystem component.</p>

                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="prerequisites">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
#### Preparing for use

To make use of the @kwaeri/filesystem component, you'll need to ensure you meet some prerequisites. The following technologies are required in order to use @kwaeri/filesystem:

* Node.js (latest version)
    * NPM (typically bundled with later Node.js installs)

The above prerequisites ensure that you are able to install - and make use of - the @kwaeri/filesystem component.

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                    <!-- Anothe Section Body Fragment -->
                                    <div id="installing-the-module" class="fragment +collapsible" data-collapsible="installing-the-module" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="installing-the-module" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Installing the Module</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="installing-the-module">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="installing-the-module">
                                                <p>This section provides step-by-step instructions for installing @kwaeri/filesystem.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="installing-the-module">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
#### Installing @kwaeri/filesystem

To install @kwaeri/filesystem, please run the following commands from terminal/command-prompt:

<!-- Show a code snippet -->
<pre class="command-line language-bash" data-user="rik" data-host="kwaeri" data-filter-output="[out]">
    <code class="language-bash">
    [out] ...
    npm install @kwaeri/filesystem
    </code>
</pre><!-- End of code snippet-->

That's it! You're set to make use of the @kwaeri/filesystem component.

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->

                                    </div> <!-- End of Fragment -->


                                    <!-- Yet Another Section Fragment-->
                                    <div id="including-the-library" class="fragment +collapsible" data-collapsible="including-the-library" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="including-the-library" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Including the Library</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="including-the-library">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="including-the-library">
                                                <p>This section provides instructions for how to include the @kwaeri/filesystem component within an application.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="including-the-library">

                                                    <!-- A markdown block for providing content to this fragment -->
                                                    <div data-markdown="render" data-rendered="false">
To include @kwaeri/filesystem in your application, add the following code to the source code you wish to make use of it in:

<!-- Show a code snippet -->
```javascript
import { Filesystem } from "@kwaeri/filesystem";
```

That's it! You're set to make use of the @kwaeri/filesystem component.

                                                    </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                    <!-- Yet Another Section Fragment-->
                                    <div id="a-complete-example" class="fragment +collapsible" data-collapsible="a-complete-example" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="a-complete-example" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">A Complete Example</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="a-complete-example">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="a-complete-example">
                                                <p>This section provides a complete example for making use of the @kwaeri/filesystem component.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="a-complete-example">

                                                    <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
Here's an example where we manipulate a filesystem the Filesystem component:

```javascript
// INCLUDES
import { Filesystem } from '@kwaeri/filesystem';


// DEFINES
let filesystem = new Filesystem();


// For now it's recommended to check out the Configuration:and Migration modules for an idea of how to use the Filesystem module more completely.
```

Check out the API section below for in-depth coverage of the available methods within the filesystem component object.
                                                    </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                </div> <!-- End of Section Body -->

                            </section> <!-- End of Section -->

                            <hr>

                            <!-- Another Section that moves on to Layout of an application using this Library -->
                            <section id="api" class="article_section">

                                <!-- Section Heading -->
                                <h2 class="article_chapter-title">API</h2>
                                <!-- End of Section Heading -->

                                <!-- Section Body -->
                                <div class="section_body">

                                    <!-- Section Body Fragment -->
                                    <div id="list" class="fragment +collapsible" data-collapsible="list" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="list" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.list()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="list">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="list">
                                                <p>This section provides instructions for making use of the .list() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="list">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
To a list of resources within a particular path, use the **list** method:

```javascript
let result = await filesystem.list( path );
```
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="getDirectoryStructure" class="fragment +collapsible" data-collapsible="getDirectoryStructure" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="getDirectoryStructure" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.getDirectoryStructure()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="getDirectoryStructure">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="getDirectoryStructure">
                                                <p>This section provides instructions for making use of the .getDirectoryStructure() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="getDirectoryStructure">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
When you want to recursively get the contents of a path, including its subdirectories, use the **getDirectoryStructure** method:

```javascript
let result = await filesystem.getDirectoryStructure( path );
```
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="getFileInformation" class="fragment +collapsible" data-collapsible="getFileInformation" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="getFileInformation" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.getFileInformation()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="getFileInformation">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="getFileInformation">
                                                <p>This section provides instructions for making use of the .getFileInformation() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="getFileInformation">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
When you want to file information and/or stat a filesystem resource, use the **getFileInformation** method:

```javascript
let result = await filesystem.getFileInformation( path );
```

The getFileInformation method wraps the core fs module's lstat method.
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="exists" class="fragment +collapsible" data-collapsible="exists" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="exists" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.exists()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="exists">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="exists">
                                                <p>This section provides instructions for making use of the .exists() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="exists">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
To check if a filesystem resource  exists, use the **exists** method:

```javascript
let result = await filesystem.exists( pathToResource );
```
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="createDirectory" class="fragment +collapsible" data-collapsible="createDirectory" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="createDirectory" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.createDirectory()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="createDirectory">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="createDirectory">
                                                <p>This section provides instructions for making use of the .createDirectory() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="createDirectory">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
To create a directory that does not already exist, use the **createDirectory** method:

```javascript
let result = await filesystem.createDirectory( path, fileName );
```
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="createFile" class="fragment +collapsible" data-collapsible="createFile" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="createFile" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.createFile()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="createFile">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="createFile">
                                                <p>This section provides instructions for making use of the .createFile() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="createFile">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
To create a file that does not already exist, use the **createFile** method:

```javascript
let result = await filesystem.createFile( path, name, content );
```

You can also base64encode the data.
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="getFileSafeName" class="fragment +collapsible" data-collapsible="getFileSafeName" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="getFileSafeName" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.getFileSafeName()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="getFileSafeName">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="getFileSafeName">
                                                <p>This section provides instructions for making use of the .getFileSafeName() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="getFileSafeName">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
When you want to transform, for instance, a code-safe string into a file-safe string - use the Filesystem's static **getFileSafeName** method:

```javascript
let fileSafeString = Filesystem.getFileSafeName( codeSafeString );
```

This will give you a string that is safe to use as a file name, within a filesystem.
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="getCodeSafeName" class="fragment +collapsible" data-collapsible="getCodeSafeName" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="getCodeSafeName" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.getCodeSafeName()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="getCodeSafeName">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="getCodeSafeName">
                                                <p>This section provides instructions for making use of the .getCodeSafeName() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="getCodeSafeName">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
When you want to transform, for instance, a file-safe string into a code-safe string - use the Filesystem's static **getCodeSafeName** method:

```javascript
let codeSafeString = Filesystem.getCodeSafeName( fileSafeString );
```

This will give you a string that is safe to use as a variable - or class - name, within  a code file.
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="alphaNumericSort" class="fragment +collapsible" data-collapsible="alphaNumericSort" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="alphaNumericSort" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.alphaNumericSort()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="alphaNumericSort">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="alphaNumericSort">
                                                <p>This section provides instructions for making use of the .alphaNumericSort() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="alphaNumericSort">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">

When you want to sort an array (i.e. of files found using the list method), use the Filesystem's **alphaNumericSort** method:

```javascript
let files = [];

files = files.sort( filesystem.alphaNumericSort() );
```

This will get you an array of items sorted alphaNumerically in ascending order.
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="getPathToCWD" class="fragment +collapsible" data-collapsible="getPathToCWD" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="getPathToCWD" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.getPathToCWD()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="getPathToCWD">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="getPathToCWD">
                                                <p>This section provides instructions for making use of the .getPathToCWD() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="getPathToCWD">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
When you want to get the full path to the current working directory, use the Filesystem's  static **getPathToCWD** method:

```javascript
let currentWorkingDirectory = Filesystem.getPathToCWD();
```

This will get you the complete path to the current working directory, or the directory the script was run with NodeJS from.
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                </div> <!-- End of Section Body -->

                            </section> <!-- End of Section -->

                        </div> <!-- End of Article Body -->


                    </article> <!-- End of Article Container -->

                </section> <!-- End of Featured Container -->

            </div> <!-- End of Container-Fluid -->

        </div> <!-- End of Focus Container -->

        <!-- Optional right column, for related, scroll-spy, or advertisement perhaps?
        <nav class="short-nav +scrollspy">
            <div class="short-nav_toolbar-spacer"></div>
            <p>Testing 1,2,3</p>
        </nav>-->

        <button class="mdc-fab material-icons app-fab--absolute" aria-label="Scroll To Top" data-scroll-to-target="top">
            <span class="mdc-fab__icon">
                keyboard_arrow_up
            </span>
        </button>

        <!-- Add JavaScript inclusions just before the closing body tag -->
        <script src="assets/js/prism.js" async></script>
        <script src="https://mmod.gitlab.io/kwaeri-user-experience/dist/js/kwaeri-ux/kux-md-bundle.min.js"></script>

    </body>
</html>